From 558f32928b27f9460e8458aeae00981fad036e7a Mon Sep 17 00:00:00 2001
From: Stephen Gallagher <sgallagh@redhat.com>
Date: Jan 18 2018 16:36:31 +0000
Subject: [PATCH 6/48] Implement ModuleAPI


---

diff --git a/modulemd/__init__.py b/modulemd/__init__.py
index 4330b3c..69ccec7 100644
--- a/modulemd/__init__.py
+++ b/modulemd/__init__.py
@@ -159,7 +159,6 @@ class ModuleMetadata(object):
         self.module.set_module_components({})
         self.module.set_rpm_artifacts(Modulemd.SimpleSet())
 
-        self.api = ModuleAPI()
         self.filter = ModuleFilter()
         self.buildopts = ModuleBuildopts()
         self.components = ModuleComponents()
@@ -687,13 +686,19 @@ class ModuleMetadata(object):
     @property
     def api(self):
         """A ModuleAPI instance representing the module's public API."""
-        return self._api
+        api = ModuleAPI(parent=self)
+        api.rpms = set(self.module.get_rpm_api().get())
+        return api
 
     @api.setter
     def api(self, o):
         if not isinstance(o, ModuleAPI):
             raise TypeError("api: data type not supported")
-        self._api = o
+
+        rpms = Modulemd.SimpleSet()
+        rpms.set(list(o.rpms))
+
+        self.module.set_rpm_api(rpms)
 
     @property
     def filter(self):
diff --git a/modulemd/api.py b/modulemd/api.py
index 41bbb90..a48d848 100644
--- a/modulemd/api.py
+++ b/modulemd/api.py
@@ -25,12 +25,15 @@
 
 supported_content = ( "rpms", )
 
+from gi.repository import Modulemd
+
 class ModuleAPI(object):
     """Class representing a particular module API."""
 
-    def __init__(self):
+    def __init__(self, parent=None):
         """Creates a new ModuleAPI instance."""
         self.rpms = set()
+        self.parent = parent
 
     def __repr__(self):
         return ("<ModuleAPI: "
@@ -57,6 +60,11 @@ class ModuleAPI(object):
                 raise TypeError("api.rpms: data type not supported")
         self._rpms = ss
 
+        if hasattr(self, 'parent'):
+            ss = Modulemd.SimpleSet()
+            ss.set(list(self.rpms))
+            self.parent.module.set_rpm_api(ss)
+
     def add_rpm(self, s):
         """Adds a binary RPM package to the API set.
 
@@ -66,6 +74,11 @@ class ModuleAPI(object):
             raise TypeError("api.add_rpm: data type not supported")
         self._rpms.add(s)
 
+        if hasattr(self, 'parent'):
+            ss = Modulemd.SimpleSet()
+            ss.set(list(self.rpms))
+            self.parent.module.set_rpm_api(ss)
+
     def del_rpm(self, s):
         """Removes the supplied package name from the API package set.
 
@@ -75,6 +88,16 @@ class ModuleAPI(object):
             raise TypeError("api.del_rpm: data type not supported")
         self._rpms.discard(s)
 
+        if hasattr(self, 'parent'):
+            ss = Modulemd.SimpleSet()
+            ss.set(list(self.rpms))
+            self.parent.module.set_rpm_api(ss)
+
     def clear_rpms(self):
         """Clear the API binary RPM package set."""
         self._rpms.clear()
+
+        if hasattr(self, 'parent'):
+            ss = Modulemd.SimpleSet()
+            ss.set(list(self.rpms))
+            self.parent.module.set_rpm_api(ss)

